clear all
close all


%% GPS station coords
Mx = 60;
My = 60;
xy = zeros(Mx*My,2);
x = linspace(15,300,Mx);
y = linspace(15,300,My);

[X,Y] = meshgrid(x,y);
xy(:,1) = X(:);
xy(:,2) = Y(:);

%% read FEM ground disp field
  h5disp =  'output_sim/eqsim-ground.h5' ;
 simdisp = hdf5read(h5disp,  '/vertex_fields/displacement') ;
 simdisp = simdisp' ;
 
  groundxy = hdf5read(h5disp,'/geometry/vertices');
  groundxy = groundxy'/1000 ;
% interpolate  
  Fx = TriScatteredInterp(groundxy(:,1:2), simdisp(:,1) ,'linear') ;
  Fy = TriScatteredInterp(groundxy(:,1:2), simdisp(:,2),'linear') ;
  Fz = TriScatteredInterp(groundxy(:,1:2), simdisp(:,3),'linear') ;
  
  disp_fem = zeros(size(xy,1),3);
  disp_fem(:,1) = Fx(xy) ;
  disp_fem(:,2) = Fy(xy) ;
  disp_fem(:,3) = Fz(xy) ;
  
  %% okada disp
  disgeom = [ 40, 12, 12, 90, 0, 0, 0, 1, 0, 0];
  okadadisp = disloc(0.25,disgeom,xy);
  
  %% plot images
  figure(1)
  dispx = okadadisp(:,1);
  dispy = okadadisp(:,2);
  dispz = okadadisp(:,3);
dispx = reshape(dispx,[My,Mx]);
dispy = reshape(dispy,[My,Mx]);
dispz = reshape(dispz,[My,Mx]);
quiver(X,Y,dispx,dispy,'LineWidth',2)
hold on
  
fdispx = disp_fem(:,1);
fdispy = disp_fem(:,2);
fdispz = disp_fem(:,3);
fdispx = reshape(fdispx,[My,Mx]);
fdispy = reshape(fdispy,[My,Mx]);
fdispz = reshape(fdispz,[My,Mx]);
quiver(X,Y,fdispx,fdispy,'r','LineWidth',1)
 
plot([0,0],[-20,20],'k', 'LineWidth',3 )
title('okada disp VS FEM disp')
legend('Okada disp','FEM disp','Location','NorthEast')

diff_plot(fdispx,dispx,X,Y)
title('Percentage of difference of X component')
%plot([0,0],[-20,20],'r', 'LineWidth',2 )

diff_plot(fdispy,dispy,X,Y)
title('Percentage of difference of Y component')
%plot([0,0],[-20,20],'r', 'LineWidth',2 )

diff_plot(fdispz,dispz,X,Y)
title('Percentage of difference of z component')